# Generated by Django 4.2.3 on 2025-06-12 05:16

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Checkpoint",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("composite_id", models.TextField(unique=True)),
                ("thread_id", models.TextField()),
                ("checkpoint_ns", models.TextField(default="")),
                ("checkpoint_id", models.TextField()),
                ("parent_checkpoint_id", models.TextField(blank=True, null=True)),
                ("type", models.TextField(blank=True, null=True)),
                ("checkpoint", models.BinaryField()),
                ("metadata", models.JSONField(default=dict)),
            ],
            options={
                "db_table": "checkpoint",
            },
        ),
        migrations.CreateModel(
            name="Write",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("task_id", models.TextField()),
                ("task_path", models.TextField()),
                ("idx", models.IntegerField()),
                ("channel", models.TextField()),
                ("type", models.TextField(blank=True, null=True)),
                ("value", models.BinaryField()),
                (
                    "checkpoint",
                    models.ForeignKey(
                        db_constraint=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="writes",
                        to="checkpoint.checkpoint",
                        to_field="composite_id",
                    ),
                ),
            ],
            options={
                "db_table": "write",
            },
        ),
        migrations.AddConstraint(
            model_name="checkpoint",
            constraint=models.UniqueConstraint(
                fields=("thread_id", "checkpoint_ns", "checkpoint_id"), name="unique_checkpoint"
            ),
        ),
        migrations.AddConstraint(
            model_name="write",
            constraint=models.UniqueConstraint(fields=("checkpoint", "task_id", "idx"), name="unique_write"),
        ),
    ]
